/*
 * m4atags
 * -------
 * Copyright 2006 by David Gerber <dg@zapek.com>
 * All Rights Reserved
 *
 * $Id$
 */

#include "m4atags.h"

/* public */
#include <mp4.h>

/* private */
#include "args.h"

int main(int argc, char **argv)
{
	if (parse_args(argc, argv))
	{
		MP4FileHandle mf;

		if ((mf = MP4Modify(args.filename, 0, 0)) != MP4_INVALID_FILE_HANDLE)
		{
			if (args.flags & ARG_STRIP)
			{
				MP4MetadataDelete(mf);
			}
		
			if (args.encoder)
			{
				if (!MP4SetMetadataTool(mf, args.encoder))
				{
					fprintf(stderr, "failed to set encoder tag\n");
				}
			}

			if (args.artist)
			{
				if (!MP4SetMetadataArtist(mf, args.artist))
				{
					fprintf(stderr, "failed to set artist tag\n");
				}
			}

			if (args.album)
			{
				if (!MP4SetMetadataAlbum(mf, args.album))
				{
					fprintf(stderr, "failed to set album tag\n");
				}
			}

			if (args.name)
			{
				if (!MP4SetMetadataName(mf, args.name))
				{
					fprintf(stderr, "failed to set name tag\n");
				}
			}

			if (args.writer)
			{
				if (!MP4SetMetadataWriter(mf, args.writer))
				{
					fprintf(stderr, "failed to set composer tag\n");
				}
			}

			if (args.comment)
			{
				if (!MP4SetMetadataComment(mf, args.comment))
				{
					fprintf(stderr, "failed to set comment tag\n");
				}
			}

			if (args.genre)
			{
				if (!MP4SetMetadataGenre(mf, args.genre))
				{
					fprintf(stderr, "failed to set genre tag\n");
				}
			}

			if (args.year)
			{
				if (!MP4SetMetadataYear(mf, args.year))
				{
					fprintf(stderr, "failed to set year tag\n");
				}
			}

			if (args.track)
			{
				if (!MP4SetMetadataTrack(mf, args.track, max(args.track, args.total_tracks)))
				{
					fprintf(stderr, "failed to set track tag\n");
				}
			}

			if (args.disk)
			{
				if (!MP4SetMetadataDisk(mf, args.disk, max(args.disk, args.total_disks)))
				{
					fprintf(stderr, "failed to set disk tag\n");
				}
			}

			MP4Close(mf);
		}
		else
		{
			fprintf(stderr, "failed to open file\n");
		}
	}
	return (0);
}
